<!DOCTYPE html>
<html lang="en">
<head>
  <%- include('../partials/head.ejs'); -%>
</head>
<body>
<%
var password = "";
var confirmPassword = "";
let status = [
                {value : "Active", title :"Active"},
                {value : "Inactive", title :"Inactive"}
              ]
%>
<div class="container bg-3">

  <%- include('../partials/header.ejs'); -%>

  <div class="row main-container">

  <div class="text-right">
    <button class="btn add-btn" data-toggle="modal" data-target="#createPatient" ><i class="fa fa-folder"></i> Add Patient</button>
  </div>
        <div class="row">
          <div class="col-sm-6 col-sm-offset-3">
            <div class="row">
              <div class="col-sm-12">
                <% if(error){ %>
                  <div class="alert alert-danger"><%= error %></div>
              <% } %>
              </div>
            </div>
          </div><!--/col-sm-6-->
        </div><!--/row-->
        <% if(patients == "patients not found"){ %>
            <h4>Patient not found.</h4>
        <% }else{ %>
        <div class="mt-2" style="background-color: rgb(255, 255, 255)">
          <div class="row">
            <div class="col">
              <div class="table-responsive mt-5">
                <table class="table table-bordered table-striped table-hover users-table mb-2">
                  <thead>
                    <tr>
                      <th>First Name</th>
                      <th>Last Name</th>
                      <th>Email</th>
                      <th>Doctor</th>
                      <th>status</th>
                      <th class="no-sort">Actions</th>
                    </tr>
                  </thead>
                  <tbody>
                    <% patients.forEach(function(patient, patientIndex){  %>
                    <tr>
                        <td><%= patient.firstName %></td>
                        <td><%= patient.lastName %></td>
                        <td><%= patient.email %></td>
                        <td>
                          <% if(patient.doctor) {%> <%= patient.doctor.first_name %> <% } %>
                          <% if(patient.doctor) {%> <%= patient.doctor.last_name %> <% } %>

                        </td>
                        <td><%= patient.status %></td>
                        <td>
                          <button class="btn viewPatient" data-id="<%= patient._id %>" ><i class="fa fa-eye"></i></button>
                          <button class="btn deletedPatient" data-id="<%= patient._id %>"><i class="fa fa-trash"></i></button>
                        </td>
                    </tr>
                    <% }) %>
                  </tbody>
                </table>
              </div>
            </div>
          </div>
        </div>
    <% } %>
  </div>
</div>

<%- include('../partials/footer.ejs'); -%>
<script>
      $(document).ready(function() {
        $(".users-table").DataTable({
          "aaSorting": [],
          "columnDefs": [ {
            "targets": 'no-sort',
            "orderable": false,
          } ]
        });

        // view doctor
        $(document).on('click', '.viewPatient', function() {
          let patientID = $(this).data('id')
          url = '/members/details/'+patientID
          window.location = url;
        })

        // Delete doctor
        $(document).on('click', '.deletedPatient', function() {
          let patientID = $(this).data('id')

          swal({
            title: "Are you sure?",
            text: "You want to delete member",
            type: "warning",
            type: "warning",
            showCancelButton: true,
            confirmButtonClass: "btn-danger",
            confirmButtonText: "Yes, delete it!",
            closeOnConfirm: false
          },
          function(){
            $.ajax({
                data:{patientID:patientID},
                url:"/members/delete",
                type: "DELETE",
                error: function(xhr) {
                },
                success: function(response) {
                    if(response.status == "error"){
                    }else{
                      swal({
                        title: "Deleted",
                        text: "",
                        type: "success",
                        confirmButtonText: "Okay"
                      },
                      function(){
                        location.reload()
                      });
                    }
                }
            });
          });
        });

        // Create form submit when click on button
        $('#createPatientButton').click(function() {
          $('#createPatient').submit()
        });

        // Create form submit
        $('#createPatient').submit(function(e) {
            e.preventDefault();
            var email = $('#email').val();
            var password = $('#password').val();
            var firstName = $('#firstName').val();
            var lastName = $('#lastName').val();
            var status = $('#status').val();
            var patientID = $('#patientID').val();
            var doctorID = $('#doctorID').val();
            var phone = $('#phone').val();

            if(status == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Status is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(patientID == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("DR ChronoID is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(firstName == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("First Name is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(lastName == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Last Name is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(email == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Email is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            const re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
            if (!re.test(email)) {
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Please enter a valid email")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }
            if(password == ""){
              $('.errorCreatePatient').show()
              $('.errorCreatePatient').html("Password is required")
              setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000)
              return false
            }



            $(this).ajaxSubmit({
                url: "/members/create",
                type: "POST",
                data:{
                        email:email,
                        password:password,
                        firstName:firstName,
                        lastName:lastName,
                        status:status,
                        phone:phone,
                        patientID:patientID,
                        doctorID:doctorID
                     },
                error: function(xhr) {
                  $('.errorCreatePatient').show()
                  $('.errorCreatePatient').html(xhr.responseJSON.message)
                  setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000);
                },
                success: function(response) {
                    if(response.status == "error"){
                      $('.errorCreatePatient').show()
                      $('.errorCreatePatient').html(response.message)
                      setTimeout(function(){ $('.errorCreatePatient').hide() }, 3000);
                    }else{
                      $('.successCreatePatient').show()
                      $('.successCreatePatient').html(response.message)
                      setTimeout(function(){ location.reload() }, 1000);
                    }
                }
            });
            //Very important line, it disable the page refresh.
            return false;
        });

        $( ".select2Dropdown" ).select2();
      });
</script>

<!-- Create Modal -->
    <div class="modal fade" id="createPatient" role="dialog">
      <div class="modal-dialog">
                      <!-- Modal content-->
       <div class="modal-content">
         <div class="modal-header">
           <button type="button" class="close" data-dismiss="modal">&times;</button>
           <h4 class="modal-title">Create Patient</h4>
         </div>
         <div class="modal-body">
           <div class="alert alert-success successCreatePatient" style="display:none"> </div>
           <div class="alert alert-danger errorCreatePatient" style="display:none"> </div>

           <form id="createClinic" action="/members/create" method="POST">
             <div class="form-group col-md-6">
                <label for="status">Status</label>
                <select id="status" name="clinicID" class="select2Dropdown select2-single">
                  <option></option>
                  <% status.forEach(function(stat, statusIndex){  %>
                    <option value="<%= stat.value %>"><%= stat.title %></option>
                  <% })  %>
                </select>
              </div>
             <div class="form-group col-md-6">
                <label for="patientID">DR ChronoID</label>
                <input type="text" class="input-lg form-control" name="patientID" id="patientID" placeholder="DR ChronoID" >
              </div>
             <div class="form-group col-md-6">
                <label for="firstName">First Name</label>
                <input type="text" class="input-lg form-control" name="firstName" id="firstName" placeholder="First name" >
              </div>
             <div class="form-group col-md-6">
                <label for="lastName">Last Name</label>
                <input type="text" class="input-lg form-control" name="lastName" id="lastName" placeholder="Last name" >
              </div>
             <div class="form-group col-md-6">
                <label for="email">Email</label>
                <input type="email" class="input-lg form-control" name="email" id="email" placeholder="email" >
              </div>
             <div class="form-group col-md-6">
                <label for="password">Password</label>
                <input type="password" class="input-lg form-control" name="password" id="password" placeholder="password" >
              </div>
             <div class="form-group col-md-6">
                <label for="phone">Mobile #</label>
                <input type="number" class="input-lg form-control" name="phone" id="phone" placeholder="Phone" >
              </div>
              <div class="form-group col-md-6">
                 <label for="status">Doctor</label>
                 <select id="doctorID" name="clinicID" class="select2Dropdown select2-single">
                   <option></option>
                   <% doctors.forEach(function(doctor, doctorIndex){  %>
                     <option value="<%= doctor._id %>"><%= doctor.first_name %> <%= doctor.last_name %></option>
                   <% })  %>
                 </select>
               </div>
            </form>
         </div>
         <div class="clearfix"></div>
         <div class="modal-footer">
           <button  class="btn" id="createPatientButton">Create Patient</button>
           <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
         </div>
       </div>

     </div>
   </div>
<!-- Create Modal -->
</body>
</html>
